package Agent;

/*
  Estende quello di default in modo da gestire anche le classi
  utilizzate dalla classe
*/

import java.io.* ;
import java.net.* ;
import java.util.* ;

public class AgentLoaderEx extends DefaultAgentLoader {

  public AgentLoaderEx() { super (); }

  protected void startAgent( AgentPacket pack )
      throws ClassNotFoundException, IOException, AgentException  {
    try {
      if ( pack instanceof AgentPacketEx ) {
        AgentPacketEx Pack = (AgentPacketEx)pack ;
        reconstructAgent( Pack ) ;
      }
      super.startAgent( pack ) ;
    } catch ( ClassCastException cce ) {
      cce.printStackTrace() ;
    }
  }

  protected void reconstructAgent( AgentPacketEx pack ) {
    AgentClassLoader cl = (AgentClassLoader)(getClass().getClassLoader()) ;
    Enumeration en = pack.usedClasses.keys() ;
    String className ;
    while ( en.hasMoreElements() ) {
      className = (String)en.nextElement() ;
      cl.addClassBytes( className, (byte[])(pack.usedClasses.get( className )) ) ;
    }
  }
}