package Agent;

import java.io.* ;
import java.net.* ;

public class AgentServerEx extends AgentServer {

  public AgentServerEx() throws IOException { super() ; }
  public AgentServerEx( int port ) throws IOException { super( port ) ; }
  
  protected void newAgentHandler( AgentServer server, Socket socket ) {
    AgentHandler Ahandler ;
    Ahandler = new AgentHandlerEx( server, socket ) ;
    Ahandler.start() ;
  }

  public static void main( String args[] ) throws IOException {
    if ( args.length > 2 )
      throw new IOException(
        "Syntax : AgentServer {<port> <messagesOn(1)>" ) ;
    int port = AgentServer.defaultPort ;
    if ( args.length > 0 )
      port = Integer.parseInt( args[ 0 ] ) ;

    System.out.println( "Starting AgentServer on port " + port ) ;

    AgentServer agentServer ;
    agentServer = new AgentServerEx( port ) ;

    if ( args.length > 1 && args[1] == "1" )
      agentServer.setMessages( true ) ;

    agentServer.start() ;
  }
}